
#property copyright "Copyright 2015, Osama M. Ben Shaban"
#property link      "http://oshaban.blogspot.com"

#define MAGIC 2015

string      Name_Expert = "Candles for Pizzo";
extern double TimeFrame = 0;
extern double        SL = 60;
extern double        TP = 120;
extern double    TrStop = 0;

extern double      Lots = 1;
extern int    LotDigits = 2;

extern bool       UseMM = false;
extern int         Risk = 10;

bool           UseSound = True;

int prevCountBars;

void init() {
}

void deinit() {
   Comment("");
}


int start(){

   if (prevCountBars != Bars && prevCountBars !=0 && !ExistPositions()) {
      
      if(Open[2]>Low[3] && High[2]<Low[1]){
         OpenBuy();
         return(0);
      }
   }

   if(TrStop != 0){
      TrailingPositionsBuy(TrStop);
   }
      
   prevCountBars = Bars;
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

void TrailingPositionsBuy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) {       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLoss(Bid-trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 

void TrailingPositionsSell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if (OrderStopLoss()>Ask+trailingStop*Point)  
                     ModifyStopLoss(Ask+trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 

void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound("alert.wav"); 
} 


void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, 3, Aqua); 
   if (fc && UseSound) PlaySound("alert.wav"); 
} 


void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); 
   if (fc && UseSound) PlaySound("alert.wav"); 
} 


void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   int ticket;
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   
   ticket=OrderSend(Symbol(),OP_BUY,ldLot,Ask,3,0,0,lsComm,MAGIC,0,Blue);
       if(ticket<0){ Print("Buy Order failed with error ",GetLastError()); }
               
         Sleep(1000);
       if(ticket>0){
         if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
         bool res = OrderModify(OrderTicket(),OrderOpenPrice(),ldStop,ldTake,0,Blue);
       }
       else
         Alert("Buy Order failed with error ",GetLastError());

   if (UseSound) PlaySound("alert.wav"); 
} 

void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   int ticket;
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
 
   ticket=OrderSend(Symbol(),OP_SELL,ldLot,Bid,3,0,0,lsComm,MAGIC,0,Red);
       if(ticket<0){ Print("Sell Order failed with error ",GetLastError()); }
               
         Sleep(1000);
       if(ticket>0){
         if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
         bool res = OrderModify(OrderTicket(),OrderOpenPrice(),ldStop,ldTake,0,Red);
       }
       else
         Alert("Sell Order failed with error ",GetLastError());

   if (UseSound) PlaySound("alert.wav"); 
} 

string GetCommentForOrder() { 	return(Name_Expert); } 
double GetStopLossBuy() { 	return (Bid-SL*Point);} 
double GetStopLossSell() { 	return(Ask+SL*Point); } 
double GetTakeProfitBuy() { 	return(Ask+TP*Point); } 
double GetTakeProfitSell() { 	return(Bid-TP*Point); } 

double GetSizeLot(){ 	
   double Lot;
   Lot = NormalizeDouble(((AccountBalance()*Risk*0.01)/1000),LotDigits);
   if (Lot>100)
      Lot = 100;
   if(!UseMM) Lot = Lots;
   return(Lot);
}   